/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem A. Auxiliary Project                                   */
/*                                                                */
/* Original idea         Georgiy Korneev                          */
/* Problem statement     Georgiy Korneev                          */
/* Test set              Georgiy Korneev                          */
/******************************************************************/
/* Tests                                                          */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.*;
import java.nio.file.*;
import java.util.*;

public class Tests {
    private static int nTests = 0;
    private static final Path root = Paths.get("tests");
    private static int MAX_N = 1_000_000;
    private static Set<Integer> used = new HashSet<>();

    private static final Random random = new Random(2347238703487348571L);

    public static void main(String[] args) throws IOException {
        Files.createDirectories(root);
        test(4);
        test(7);
        test(6);
        for (int i = 3; i < 10; i++) {
            if (!used.contains(i)) {
                test(i);
            }
        }
        for (int i = 100; i <= MAX_N; i *= 100) {
            for (int j = 0; j < 3; j++) {
                random.ints(3, i / 100 + 1, i + 1).forEach(Tests::test);
            }
        }
        for (int i = MAX_N - 5; i <= MAX_N; i++) {
            test(i);
        }
    }

    private static void test(final int n) {
        if (!used.add(n)) {
            throw new AssertionError("Duplicate n " + n);
        }
        try (PrintWriter out = new PrintWriter(String.format("%s/%02d", root, ++nTests))) {
            System.out.println("Writing test " + nTests);
            out.println(n);
        } catch (IOException e) {
            throw new AssertionError(e);
        }
    }
}

