/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem A. Auxiliary Project                                   */
/*                                                                */
/* Original idea         Georgiy Korneev                          */
/* Problem statement     Georgiy Korneev                          */
/* Test set              Georgiy Korneev                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class auxiliary_gk_n {
    private static Scanner in;
    private static PrintWriter out;
    private static int[] DIGITS = {6, 2, 5, 5, 4, 5, 6, 3, 7, 6};

    private static class Solution {
        void run() {
            out.println(solve(in.nextInt()));
        }

        private int solve(final int n) {
            int[] best = new int[n + 1];
            best[1] = Integer.MIN_VALUE;
            for (int i = 2; i <= n ; i++) {
                for (int d = 0; d <= 9; d++) {
                    if (i - DIGITS[d] >= 0) {
                        best[i] = Math.max(best[i], best[i - DIGITS[d]] + d);
                    }
                }
            }
            return best[n];
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("auxiliary.in"));
        out = new PrintWriter("auxiliary.out");

        new Solution().run();

        in.close();
        out.close();
    }
}

