/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem B. Boolean Satisfiability                              */
/*                                                                */
/* Original idea         Gennady Korotkevich                      */
/* Problem statement     Pavel Mavrin                             */
/* Test set              Pavel Mavrin                             */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.BitSet;

public class boolean_gk {
    private static Scanner in;
    private static PrintWriter out;
    private static String VARS = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";

    private static class Solution {
        void run() {
            out.println(solve(in.nextLine()));
        }

        private long solve(final String s) {
            BitSet positive = new BitSet(VARS.length());
            BitSet negative = new BitSet(VARS.length());

            boolean neg = false;
            for (char ch : s.replace("|","").toCharArray()) {
                if (ch == '~') {
                    neg = true;
                } else {
                    (neg ? negative : positive).set(VARS.indexOf(ch));
                    neg = false;
                }
            }
            BitSet intersection = (BitSet) positive.clone();
            intersection.and(negative);
            BitSet union = (BitSet) positive.clone();
            union.or(negative);
            return (1L << union.cardinality()) - (intersection.isEmpty() ? 1 : 0);
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("boolean.in"));
        out = new PrintWriter("boolean.out");

        new Solution().run();

        in.close();
        out.close();
    }
}

