/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem C. Consonant Fencity                                   */
/*                                                                */
/* Original idea         Andrei Lopatin                           */
/* Problem statement     Andrei Lopatin                           */
/* Test set              Andrei Lopatin                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class consonant_gk_ok_gray {
    static BufferedReader in;
    static PrintWriter out;
    static final String LETTERS = "bcdfghjklmnpqrstvxzaeiouwy";
    static final int CONS = 19;


    private static class Solution {
        void run() throws IOException {
            out.println(solve(in.readLine()));
        }

        private String solve(final String word) {
            int[][] c = new int[LETTERS.length()][LETTERS.length()];
            int prev = LETTERS.length() - 1;
            for (int i = 0; i < word.length(); i++) {
                int v = LETTERS.indexOf(word.charAt(i));
                c[v][prev]++;
                c[prev][v]++;
                prev = v;
            }

            int best = 0;
            int bestMask = 0;
            int total = 0;
            int prevMask = 0;
            for (int g = 1; g < 1 << (CONS - 1); g++) {
                final int mask = g ^ (g >> 1);
                for (int i = 0; i < CONS; i++) {
                    if (((mask ^ prevMask) & (1 << i)) != 0) {
                        final boolean bm = (mask & (1 << i)) == 0;
                        for (int j = 0; j < CONS; j++) {
                            if (i == j) {
                                continue;
                            }
                            if (bm ^ ((mask & (1 << j)) == 0)) {
                                total += c[i][j];
                            } else {
                                total -= c[i][j];
                            }
                        }
                    }
                }
                if (total > best) {
                    best = total;
                    bestMask = mask;
                }
                prevMask = mask;
            }

            StringBuilder sb = new StringBuilder();
            for (char ch : word.toCharArray()) {
                int v = LETTERS.indexOf(ch);
                sb.append((bestMask & (1 << v)) == 0 ? ch : Character.toUpperCase(ch));

            }
            return sb.toString();
        }
    }

    public static void main(String[] args) throws Exception {
        in = new BufferedReader(new FileReader("consonant.in"));
        out = new PrintWriter("consonant.out");

        new Solution().run();

        in.close();
        out.close();
    }
}

