/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem D. Dividing Marbles                                    */
/*                                                                */
/* Original idea         Gennady Korotkevich                      */
/* Problem statement     Gennady Korotkevich                      */
/* Test set              Gennady Korotkevich                      */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Borys Minaiev                            */
/******************************************************************/

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class dividing_bm {
    private FastScanner in;
    private PrintWriter out;

    int[][] best;
    int[] bestSize;
    int[] cur = new int[100];
    long START;
    int MAX = 1;

    void go(int sz) {
        int last = cur[sz - 1];
        if (last >= MAX) {
            return;
        }
        if (Long.bitCount(last) > 4) {
            return;
        }

        if ((1 << Math.max(0, (sz - 3))) >= Math.max(2, last)) {
            return;
        }
        for (int tc : queries[last]) {
            if (bestSize[tc] > sz) {
                bestSize[tc] = sz;
                best[tc] = cur.clone();
            }
        }
        for (int x = sz - 1; x >= 0; x--) {
            if (cur[x] * 2 <= last) {
                break;
            }
            for (int y = x; y >= 0; y--) {
                cur[sz] = cur[x] + cur[y];
                if (cur[sz] > last) {
                    go(sz + 1);
                } else {
                    break;
                }
            }
        }
    }

    ArrayList<Integer>[] queries;

    private void solve() {
        START = System.currentTimeMillis();
        int tc = in.nextInt();

        bestSize = new int[tc];
        best = new int[tc][];
        Arrays.fill(bestSize, 100);
        int[] qq = new int[tc];
        for (int t = 0; t < tc; t++) {
            int s = 0;
            for (int i = 0; i < 4; i++) {
                s += 1 << in.nextInt();
            }
            if (Long.bitCount(s) > 3) {
                MAX = Math.max(MAX, s + 1);
            }
            qq[t] = s;
        }
        queries = new ArrayList[MAX];
        for (int i = 0; i < MAX; i++) {
            queries[i] = new ArrayList<>();
        }
//        System.err.println("max = " + MAX);
        for (int i = 0; i < tc; i++) {
            if (Long.bitCount(qq[i]) <= 3) {
                continue;
            }
//            System.err.println(Integer.bitCount(qq[i]));
            queries[qq[i]].add(i);
        }
        cur[0] = 1;
        go(1);
        for (int t = 0; t < tc; t++) {
//            System.err.println("t = " + t);
            int bSz = bestSize[t];
            int[] be = best[t];
            if (best[t] == null) {
//                System.err.println("not found");
                int need = qq[t];
                bSz = 1;
                cur[0] = 1;
                while (cur[bSz - 1] * 2 <= need) {
                    cur[bSz] = cur[bSz - 1] * 2;
                    bSz++;
                }
                int now = cur[bSz - 1];
                for (int i = 0; i < 30; i++) {
                    if (((1 << i) & need) != 0) {
                        if (((1 << i) & now) == 0) {
                            now |= 1 << i;
                            cur[bSz++] = now;
                        }
                    }
                }
                be = cur.clone();

//                System.err.println("t = " + t);
//                System.err.println(Integer.toBinaryString(qq[t]));
//                for (int i = 0; i < bSz; i++) {
//                    System.err.println(Integer.toBinaryString(be[i]));
//                }
            }
            if (be[bSz - 1] != qq[t]) {
                throw new AssertionError();
            }
            out.println(bSz - 1);
            for (int i = bSz - 1; i > 0; i--) {
                int check = be[i];
                boolean found = false;
                out:
                for (int j = 0; j < i; j++) {
                    for (int k = 0; k <= j; k++) {
                        if (be[j] + be[k] == check) {
                            out.println(check + " " + be[j] + " " + be[k]);
                            found = true;
                            break out;
                        }
                    }
                }
                if (!found) {
                    throw new AssertionError();
                }
            }
        }
        System.err.println(System.currentTimeMillis() - START);
    }

    private void run() {
        try {
            in = new FastScanner(new File("dividing.in"));
            out = new PrintWriter(new File("dividing.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    private void runIO() {
        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    private class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }
    }

    public static void main(String[] args) {
        new dividing_bm().run();
    }
}
