/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem D. Dividing Marbles                                    */
/*                                                                */
/* Original idea         Gennady Korotkevich                      */
/* Problem statement     Gennady Korotkevich                      */
/* Test set              Gennady Korotkevich                      */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Gennady Korotkevich                      */
/******************************************************************/

/**
 *    author:  tourist
 *    created: 21.10.2017 09:58:07
**/
#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 20;
const int BITS = 4;

vector<int> cases[1 << (MAX_N + 1)];
int ans;
int max_n;
int a[MAX_N + 10];
vector< vector<int> > res;
long long iters = 0;

void dfs(int v) {
  iters++;
  if (a[v] > max_n || (v >= 2 && a[v] < (1 << (v - 2)))) {
    return;
  }
  if (!cases[a[v]].empty()) {
    for (int qq : cases[a[v]]) {
      res[qq].resize(v + 1);
      for (int j = 0; j <= v; j++) {
        res[qq][j] = a[j];
      }
    }
    cases[a[v]].clear();
    return;
  }
  for (int i = v; i >= 0; i--) {
    if (2 * a[i] <= a[v]) {
      break;
    }
    for (int j = i; j >= 0; j--) {
      if (a[i] + a[j] > a[v]) {
        a[v + 1] = a[i] + a[j];
        dfs(v + 1);
      } else {
        break;
      }
    }
  }
}

int main() {
  freopen("dividing.in", "r", stdin);
  freopen("dividing.out", "w", stdout);
  int tt;
  scanf("%d", &tt);
  res.resize(tt);
  max_n = 0;
  for (int qq = 0; qq < tt; qq++) {
    int n = 0;
    for (int i = 0; i < BITS; i++) {
      int foo;
      scanf("%d", &foo);
      n += (1 << foo);
    }
    vector<int> bits;
    for (int j = 30; j >= 0; j--) {
      if (n & (1 << j)) {
        bits.push_back(j);
      }
    }
    res[qq].resize(bits[0] + (int) bits.size());
    for (int i = 0; i <= bits[0]; i++) {
      res[qq][i] = (1 << i);
    }
    for (int i = 1; i < (int) bits.size(); i++) {
      res[qq][bits[0] + i] = res[qq][bits[0] + i - 1] + (1 << bits[i]);
    }
    if ((int) bits.size() == 4) {
      max_n = max(max_n, n);
      cases[n].push_back(qq);
    }
  }
  a[0] = 1;
  dfs(0);
  cerr << "iters = " << iters << endl;
  cerr << "after dfs: time = " << clock() << " ms" << endl;
  for (int qq = 0; qq < tt; qq++) {
    int sz = res[qq].size();
    cout << sz - 1 << endl;
    for (int i = sz - 1; i > 0; i--) {
      int x = -1, y = -1;
      for (int j = i - 1; j >= 0; j--) {
        for (int k = i - 1; k >= 0; k--) {
          if (res[qq][j] + res[qq][k] == res[qq][i]) {
            x = j;
            y = k;
          }
        }
      }
      assert(x != -1);
      cout << res[qq][i] << " " << res[qq][x] << " " << res[qq][y] << endl;
    }
  }
  cerr << "after output: time = " << clock() << " ms" << endl;
  return 0;
}

