/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem D. Dividing Marbles                                    */
/*                                                                */
/* Original idea         Gennady Korotkevich                      */
/* Problem statement     Gennady Korotkevich                      */
/* Test set              Gennady Korotkevich                      */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Gennady Korotkevich                      */
/******************************************************************/

/**
 *    author:  tourist
 *    created: 30.10.2017 13:48:43
**/
#include <bits/stdc++.h>

using namespace std;

const int INPUT_BITS = 4;

#define bit(i) (1LL << (i))

int main() {
  freopen("dividing.in", "r", stdin);
  freopen("dividing.out", "w", stdout);
  int tt;
  cin >> tt;
  while (tt--) {
    long long n = 0;
    for (int i = 0; i < INPUT_BITS; i++) {
      int d;
      cin >> d;
      n += bit(d);
    }
    vector<int> bits;
    for (int j = 62; j >= 0; j--) {
      if (n & bit(j)) {
        bits.push_back(j);
      }
    }
    int cnt = bits.size();
    vector<long long> chain;
    for (int i = 0; i < bits[0]; i++) {
      chain.push_back(bit(i));
    }
    long long sum = 0;
    for (int j = 0; j < (int) bits.size(); j++) {
      sum += bit(bits[j]);
      chain.push_back(sum);
    }
    if (cnt == 4) {
      int k0 = bits[0];
      int k1 = bits[1];
      int k2 = bits[2];
      int k3 = bits[3];
      // 1 4* 1  @(p)+@(p-5)+@(p-6)+@(p-7)
      if (k1 == k0 - 5 && k2 == k0 - 6 && k3 == k0 - 7) {
        chain.clear();
        for (int i = 0; i <= k0 - 6; i++) {
          chain.push_back(bit(i));
        }
        chain.push_back(bit(k0 - 6) + bit(k0 - 7));
        chain.push_back(bit(k0 - 5) + bit(k0 - 7));
        chain.push_back(bit(k0 - 4) + bit(k0 - 6));
        chain.push_back(bit(k0 - 3) + bit(k0 - 5));
        chain.push_back(bit(k0 - 2) + bit(k0 - 4));
        chain.push_back(bit(k0 - 2) + bit(k0 - 4) + bit(k0 - 5) + bit(k0 - 7));
        chain.push_back(bit(k0 - 1) + bit(k0 - 3) + bit(k0 - 4) + bit(k0 - 6));
        chain.push_back(n);
      }
      // 2 4* 2  @(p)+@(p-3)+@(q)+@(q-1)
      if (k1 == k0 - 3 && k3 == k2 - 1) {
        chain.clear();
        for (int i = 0; i <= k0 - 3; i++) {
          chain.push_back(bit(i));
        }
        chain.push_back(bit(k0 - 3) + bit(k0 - 4));
        chain.push_back(bit(k0 - 3) + bit(k0 - 4) + bit(k2 - 1));
        chain.push_back(bit(k0 - 2) + bit(k0 - 3) + bit(k2 - 1));
        chain.push_back(bit(k0 - 1) + bit(k0 - 2) + bit(k2));
        chain.push_back(n);
      }
      // 3 4* 3  @(p)+@(q)+@(r)+@(-p+q+r)
      if (k0 - k1 == k2 - k3) {
        chain.clear();
        for (int i = 0; i <= k2; i++) {
          chain.push_back(bit(i));
        }
        chain.push_back(bit(k2) + bit(k3));
        for (int i = k2 + 1; i <= k0; i++) {
          chain.push_back(bit(i) + bit(i - (k0 - k1)));
        }
        chain.push_back(n);
      }
      // 4 4* 3  @(p)+@(q)+@(r)+@(-p+q+r+1)
      if (k0 - k1 == k2 - k3 + 1) {
        chain.clear();
        for (int i = 0; i <= k2; i++) {
          chain.push_back(bit(i));
        }
        chain.push_back(bit(k2) + bit(k3));
        chain.push_back(bit(k2 + 1) + bit(k3));
        for (int i = k2 + 2; i <= k0; i++) {
          chain.push_back(bit(i) + bit(i - (k0 - k1)));
        }
        chain.push_back(n);
      }
    }
    int sz = chain.size();
    cout << sz - 1 << endl;
    for (int i = sz - 1; i > 0; i--) {
      int x = -1, y = -1;
      for (int j = 0; j < i; j++) {
        for (int k = 0; k < i; k++) {
          if (chain[j] + chain[k] == chain[i]) {
            x = j;
            y = k;
          }
        }
      }
      assert(x != -1);
      cout << chain[i] << " " << chain[x] << " " << chain[y] << endl;
    }
  }
  return 0;
}

