/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem D. Dividing Marbles                                    */
/*                                                                */
/* Original idea         Gennady Korotkevich                      */
/* Problem statement     Gennady Korotkevich                      */
/* Test set              Gennady Korotkevich                      */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.*;

public class dividing_gk_ok_chain_minor {
    private static Scanner in;
    private static PrintWriter out;

    private static class Solution {
        int read() {
            return 1 << in.nextInt();
        }
        int[][] chains;
        Map<Integer, List<Integer>> indices = new HashMap<>();
        int[] chain = new int[24];

        void run() {
            int t = in.nextInt();
            for (int i = 0; i < t; i++) {
                final int n = read() + read() + read() + read();
                indices.computeIfAbsent(n, k -> new ArrayList<>()).add(i);
            }
            chains = new int[t][];
            chain[0] = 1;
            find(1, 3);
            for (int[] chain : chains) {
                out.println(chain.length - 1);
                for (int i = chain.length - 1; i >= 1; i--) {
                    out.println(chain[i] + " " + chain[i - 1] + " " + (chain[i] - chain[i - 1]));
                }
            }
        }

        private void find(final int i, int minors) {
//            System.out.println(Arrays.toString(Arrays.copyOf(chain, i)));
            final List<Integer> inds = indices.get(chain[i - 1]);
            if (inds != null) {
                for (Integer ind : inds) {
                    if (chains[ind] == null || chains[ind].length > i) {
                        chains[ind] = Arrays.copyOf(chain, i);
                    }
                }
            }
            if (i == chain.length) {
                return;
            }
            chain[i] = chain[i - 1] * 2;
            find(i + 1, minors);
            if (minors > 0) {
                for (int j = 0; j < i - 1; j++) {
                    chain[i] = chain[i - 1] + chain[j];
                    find(i + 1, minors - 1);
                }
            }
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("dividing.in"));
        out = new PrintWriter("dividing.out");

        new Solution().run();

        in.close();
        out.close();
    }
}

