/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem D. Dividing Marbles                                    */
/*                                                                */
/* Original idea         Gennady Korotkevich                      */
/* Problem statement     Gennady Korotkevich                      */
/* Test set              Gennady Korotkevich                      */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class dividing_gk_ok_construct {
    private static Scanner in;
    private static PrintWriter out;

    private static class Solution {
        long read() {
            return 1L << in.nextInt();
        }

        void run() {
            solve(read() + read() + read() + read());
        }

        private void solve(long n) {
            int[] ones = new int[4];
            int bits = 0;
            for (long z = 1, i = 0; z <= n; z *= 2, i++) {
                if ((n & z) != 0) {
                    ones[bits++] = (int) i;
                }
                if (z > n / 2) {
                    break;
                }
            }
            List<Long> chain = new ArrayList<>();
            chain.add(1L);
            if (bits == 4) {
                if (ones[1] - ones[0] == ones[3] - ones[2]) {
                    // (1<<n+1)<<m + (1<<n+1)
                    dbl(chain, ones[1]);
                    int z = chain.size();
                    add(chain, ones[0]);
                    dbl(chain, ones[3] - ones[1]);
                    add(chain, z);
                } else if (ones[3] - ones[2] == ones[1] - ones[0] + 1) {
                    // x -> 1.5x -> 2.5x
                    dbl(chain, ones[1]);
                    int z = chain.size();
                    add(chain, ones[0], chain.size() - 1);
                    dbl(chain, ones[3] - (ones[1] + 2) + 1);
                    add(chain, z);
                } else if (ones[3] - ones[2] == 3 && ones[1] - ones[0] == 1) {
                    // 3 -> 6 -> 9 -> (9 << n) + 3
                    dbl(chain, ones[0]);
                    int z = chain.size();
                    add(chain, z - 1, z - 1, z + 1, z + 1);
                    dbl(chain, ones[2] - (ones[1] + 1) + 1);
                    add(chain,z + 1, chain.size() - 1);
                } else if (ones[3] - ones[2] == 5 && ones[2] - ones[1] == 1 && ones[1] - ones[0] == 1) {
                    // 135<<n
                    add(chain, 0, 0, 1, 3, 3);
                    dbl(chain, 3);
                    add(chain, 5);
                    dbl(chain, ones[0]);
                } else {
                    simple(ones, bits, chain);
                }
            } else {
                simple(ones, bits, chain);
            }

            out.println(chain.size() - 1);
            for (int i = chain.size() - 1; i >= 1; i--) {
                out.println(chain.get(i) + " " + chain.get(i - 1) + " " + (chain.get(i) - chain.get(i - 1)));

            }
        }

        private void dbl(final List<Long> chain, final int count) {
            for (int i = 0; i < count; i++) {
                add(chain, chain.size() - 1);
            }
        }

        private void simple(final int[] ones, final int bits, final List<Long> chain) {
            dbl(chain, ones[bits - 1]);
            for (int i = 0; i < bits - 1; i++) {
                final int j = ones[i];
                add(chain, j);
            }
        }

        private void add(final List<Long> chain, final int... indices) {
            for (int i : indices) {
                chain.add(chain.get(chain.size() - 1) + chain.get(i));
            }
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("dividing.in"));
        out = new PrintWriter("dividing.out");

        int t = in.nextInt();
        for (int i = 0; i < t; i++) {
            new Solution().run();
        }

        in.close();
        out.close();
    }
}

