/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem F. Fygon 2.0                                           */
/*                                                                */
/* Original idea         Artem Vasilyev                           */
/* Problem statement     Artem Vasilyev                           */
/* Test set              Artem Vasilyev                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class fygon20_gk {
    static Scanner in;
    static PrintWriter out;
    static Pattern FOR = Pattern.compile(" *for ([a-z]) in range\\(([1a-z]), ([1a-z])\\):");

    static class Less {
        int i, j;

        Less(final int i, final int j) {
            this.i = i;
            this.j = j;
        }

        @Override
        public String toString() {
            return "{" + i + ", " + j + '}';
        }
    }

    static class Solution {
        void run() {
            StringBuilder sb = new StringBuilder("1n");
            int n = in.nextInt() - 1;
            in.nextLine();
            int[] lower = new int[n];
            int[] upper = new int[n];
            for (int i = 0; i < n; i++) {
                final Matcher matcher = FOR.matcher(in.nextLine());
                matcher.find();
                sb.append(matcher.group(1));
                lower[i] = sb.indexOf(matcher.group(2));
                upper[i] = sb.indexOf(matcher.group(3));
            }
            out.println(solve(lower, upper));
        }

        String solve(final int[] lower, final int[] upper) {
            final int n = lower.length;
            List<Less> tests = new ArrayList<>();
            for (int i = 0; i < n; i++) {
                if (lower[i] != 0) {
                    tests.add(new Less(lower[i] - 2, i));
                }
                if (upper[i] != 1) {
                    tests.add(new Less(i, upper[i] - 2));
                }
            }

            boolean[][] less = new boolean[n][n];
            for (Less test : tests) {
                less[test.i][test.j] = true;
            }

            for (int k = 0; k < n; k++) {
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < n; j++) {
                        less[i][j] |= less[i][k] && less[k][j];
                    }
                }
            }

            int[] substs = new int[n];
            Arrays.fill(substs, -1);
            int c = 0;
            for (int i = 0; i < n; i++) {
                if (substs[i] != -1) {
                    continue;
                }
                substs[i] = c++;
                if (less[i][i]) {
                    for (int j = i + 1; j < n; j++) {
                        if (substs[j] == -1 && less[i][j] && less[j][i]) {
                            substs[j] = substs[i];
                        }
                    }
                }
            }

            for (Less test : tests) {
                test.i = substs[test.i];
                test.j = substs[test.j];
            }
            int[] greater = new int[c];
            for (Less test : tests) {
                if (test.i != test.j) {
                    greater[test.i] |= 1 << test.j;
                }
            }

            long[] count = new long[1 << c];
            count[0] = 1;
            for (int mask = 0; mask < count.length; mask++) {
                for (int i = 0; i < c; i++) {
                    if ((mask & (1 << i)) == 0 && (mask & greater[i]) == 0) {
                        count[mask | (1 << i)] += count[mask];
                    }
                }
            }

            long sum = count[count.length - 1];

            long div = 1;
            for (int i = 2; i <= c; i++) {
                div *= i;
            }

            for (int i = 2; i <= c; i++) {
                while (sum % i == 0 && div % i == 0) {
                    sum /= i;
                    div /= i;
                }
            }
            return c + " " + sum + "/" + div;
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("fygon20.in"));
        out = new PrintWriter("fygon20.out");

        new Solution().run();

        in.close();
        out.close();
    }
}

