/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem H. Hidden Supervisors                                  */
/*                                                                */
/* Original idea         Niyaz Nigmatullin                        */
/* Problem statement     Niyaz Nigmatullin                        */
/* Test set              Niyaz Nigmatullin                        */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Georgiy Korneev                          */
/******************************************************************/

import java.io.*;
import java.util.*;

public class hidden_gk_ok_fast {
    static Scanner in;
    static PrintWriter out;

    static class Solution {
        int[] empty;
        List<List<Integer>> children = new ArrayList<>();
        int[] parent;
        int[] special;
        List<List<Integer>> free = new ArrayList<>();

        void run() {
            int n = in.nextInt();

            empty = new int[n];
            special = new int[n];
            Arrays.fill(special, -1);
            for (int i = 0; i < n; i++) {
                children.add(new ArrayList<>());
                free.add(null);
            }

            parent = new int[n];
            parent[0] = -1;
            for (int i = 1; i < n; i++) {
                parent[i] = in.nextInt() - 1;
                if (parent[i] != -1) {
                    children.get(parent[i]).add(i);
                }
            }

            Deque<Integer> free = new ArrayDeque<>();
            Deque<Integer> candidates = new ArrayDeque<>();
            int size = 0;
            final int root = 0;
            for (int i = 0; i < n; i++) {
                if (parent[i] == -1) {
                    dfs(i);
                    size += size(i);
                    if (i != root) {
                        if (special[i] != -1) {
                            parent[i] = root;
                            free(i, false, free);
                        } else {
                            this.free.set(i, new ArrayList<>());
                            free(i, true, this.free.get(i));
                            if (this.free.get(i).isEmpty()) {
                                candidates.add(i);
                            } else {
                                candidates.push(i);
                            }
                        }
                    } else {
                        free(i, false, free);
                    }
                }
            }

            while (!candidates.isEmpty()) {
                int i = candidates.pop();
                if (!free.isEmpty()) {
                    parent[i] = free.pop();
                    free.addAll(this.free.get(i));
                    size++;
                } else if (!candidates.isEmpty()) {
                    int p = candidates.pop();
                    this.parent[i] = p;
                    this.parent[p] = root;
                    free.addAll(this.free.get(i));
                    free.addAll(this.free.get(p));
                    size++;
                } else {
                    parent[i] = root;
                }
            }

            out.println(size);
            for (int i = 1; i < n; i++) {
                out.println(parent[i] + 1);
            }
        }

        private void dfs(final int i) {
            for (int c : children.get(i)) {
                dfs(c);
                empty[i] += size(c);
                if (special[i] == -1 && special[c] == -1) {
                    special[i] = c;
                }
            }
        }

        void free(int i, final boolean used, Collection<Integer> free) {
            for (int c : children.get(i)) {
                free(c, !used && c == special[i], free);
            }
            if (!used && special[i] == -1) {
                free.add(i);
            }
        }

        int size(int i) {
            return empty[i] + (special[i] != -1 ? 1 : 0);
        }
    }

    public static void main(String[] args) throws Exception {
        in = new Scanner(new File("hidden.in"));
        out = new PrintWriter("hidden.out");

        new Solution().run();

        in.close();
        out.close();
    }

    static class Scanner {
        final BufferedReader reader;
        StringTokenizer tokenizer = new StringTokenizer("");

        Scanner(File file) throws FileNotFoundException {
            reader = new BufferedReader(new FileReader(file));
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        String next() {
            while (!tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new AssertionError();
                }
            }
            return tokenizer.nextToken();
        }

        void close() {
        }
    }
}

