/******************************************************************/
/* ACM ICPC 2017-2018, NEERC                                      */
/* Northern Subregional Contest                                   */
/* St Petersburg, November 4, 2017                                */
/******************************************************************/
/* Problem L. Little Difference                                   */
/*                                                                */
/* Original idea         Dmitry Yakutov                           */
/* Problem statement     Pavel Kunyavskiy                         */
/* Test set              Pavel Kunyavskiy                         */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Kunyavskiy                         */
/******************************************************************/

#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

vector<vector<long long>> answers;

void solve(long long n, long long a) {
  vector<long long> v;
  while (n % a == 0) {
    v.push_back(a);
    n /= a;
  }
  while (n % (a + 1) == 0) {
    v.push_back(a + 1);
    n /= a + 1;
  }
  if (n == 1) {
    answers.push_back(v);
  }
}

int main() {
  assert(freopen("little.in", "r", stdin));
  assert(freopen("little.out", "w", stdout));

  long long n;
  cin >> n;

  if ((n & (n - 1)) == 0) {
    printf("-1\n");
    return 0;
  }

  solve(n, n);
  for (int s = 1; s <= 64; s++) {
    long long r = (long long)pow(n, 1.0 / s);
    for (int j = -2; j <= 2; j++) {
      if (r + j > 1) {
        solve(n, r + j);
      }
    }
  }
  sort(answers.begin(), answers.end());
  answers.erase(unique(answers.begin(), answers.end()), answers.end());

  printf("%d\n", (int)answers.size());
  for (const auto& x: answers) {
    cout << x.size();
    for (long long y : x) {
      cout << " " << y;
    }
    cout << endl;
  }
}

